Index: trunk/sources/HeuristicLab.Routing.TSP/3.3/HeuristicLab.Routing.TSP-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Routing.TSP/3.3/HeuristicLab.Routing.TSP-3.3.csproj	(revision 2857)
+++ trunk/sources/HeuristicLab.Routing.TSP/3.3/HeuristicLab.Routing.TSP-3.3.csproj	(revision 2865)
@@ -80,8 +80,11 @@
     </Reference>
     <Reference Include="System.Data" />
+    <Reference Include="System.Drawing" />
     <Reference Include="System.Xml" />
   </ItemGroup>
   <ItemGroup>
     <None Include="HeuristicLabRoutingTSPPlugin.cs.frame" />
+    <Compile Include="TSPEvaluator.cs" />
+    <Compile Include="ITSPEvaluator.cs" />
     <Compile Include="TSPDistanceMatrixPathEvaluator.cs" />
     <Compile Include="TSPLIBParser.cs" />
@@ -96,4 +99,8 @@
       <Project>{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}</Project>
       <Name>HeuristicLab.Collections-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Common.Resources\3.2\HeuristicLab.Common.Resources-3.2.csproj">
+      <Project>{0E27A536-1C4A-4624-A65E-DC4F4F23E3E1}</Project>
+      <Name>HeuristicLab.Common.Resources-3.2</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
Index: trunk/sources/HeuristicLab.Routing.TSP/3.3/HeuristicLabRoutingTSPPlugin.cs.frame
===================================================================
--- trunk/sources/HeuristicLab.Routing.TSP/3.3/HeuristicLabRoutingTSPPlugin.cs.frame	(revision 2857)
+++ trunk/sources/HeuristicLab.Routing.TSP/3.3/HeuristicLabRoutingTSPPlugin.cs.frame	(revision 2865)
@@ -29,4 +29,5 @@
   [PluginFile("HeuristicLab.Routing.TSP-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
+  [PluginDependency("HeuristicLab.Common.Resources", "3.2")]
   [PluginDependency("HeuristicLab.Core", "3.3")]
   [PluginDependency("HeuristicLab.Data", "3.3")]
Index: trunk/sources/HeuristicLab.Routing.TSP/3.3/ITSPEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.Routing.TSP/3.3/ITSPEvaluator.cs	(revision 2865)
+++ trunk/sources/HeuristicLab.Routing.TSP/3.3/ITSPEvaluator.cs	(revision 2865)
@@ -0,0 +1,29 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Routing.TSP {
+  /// <summary>
+  /// An interface which represents an evaluation operator for Traveling Salesman Problems.
+  /// </summary>
+  public interface ITSPEvaluator : ISingleObjectiveEvaluator { }
+}
Index: trunk/sources/HeuristicLab.Routing.TSP/3.3/TSP.cs
===================================================================
--- trunk/sources/HeuristicLab.Routing.TSP/3.3/TSP.cs	(revision 2857)
+++ trunk/sources/HeuristicLab.Routing.TSP/3.3/TSP.cs	(revision 2865)
@@ -20,4 +20,7 @@
 #endregion
 
+using System;
+using System.Drawing;
+using System.Linq;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
@@ -26,5 +29,5 @@
 using HeuristicLab.Permutation;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using System;
+using HeuristicLab.PluginInfrastructure;
 
 namespace HeuristicLab.Routing.TSP {
@@ -32,23 +35,79 @@
   [Creatable("Problems")]
   [EmptyStorableClass]
-  public sealed class TSP : SingleObjectiveProblem {
-    private ValueParameter<DoubleMatrixData> CoordinatesParameter {
-      get { return (ValueParameter<DoubleMatrixData>)Parameters["Coordinates"]; }
+  public sealed class TSP : ParameterizedNamedItem, ISingleObjectiveProblem {
+    public override Image ItemImage {
+      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.Type; }
     }
 
-    public DoubleMatrixData Coordinates {
-      get { return CoordinatesParameter.Value; }
-      set { CoordinatesParameter.Value = value; }
+    private IValueParameter<BoolData> MaximizationParameter {
+      get { return (IValueParameter<BoolData>)Parameters["Maximization"]; }
+    }
+    public IValueParameter<DoubleMatrixData> CoordinatesParameter {
+      get { return (IValueParameter<DoubleMatrixData>)Parameters["Coordinates"]; }
+    }
+    public IValueParameter<DoubleData> BestKnownQualityParameter {
+      get { return (IValueParameter<DoubleData>)Parameters["BestKnownQuality"]; }
+    }
+    public IValueParameter<IPermutationCreator> SolutionCreatorParameter {
+      get { return (IValueParameter<IPermutationCreator>)Parameters["SolutionCreator"]; }
+    }
+    public IValueParameter<ITSPEvaluator> EvaluatorParameter {
+      get { return (IValueParameter<ITSPEvaluator>)Parameters["Evaluator"]; }
+    }
+
+    public BoolData Maximization {
+      get { return MaximizationParameter.Value; }
+    }
+    public ISolutionCreator SolutionCreator {
+      get { return SolutionCreatorParameter.Value; }
+    }
+    public ISingleObjectiveEvaluator Evaluator {
+      get { return EvaluatorParameter.Value; }
+    }
+    IEvaluator IProblem.Evaluator {
+      get { return EvaluatorParameter.Value; }
+    }
+    private OperatorSet operators;
+    public OperatorSet Operators {
+      get { return operators; }
     }
 
     public TSP()
       : base() {
-      Maximization = new BoolData(false);
+      ValueParameter<BoolData> maximizationParameter = new ValueParameter<BoolData>("Maximization", "Set to false as the Traveling Salesman Problem is a minimization problem.", new BoolData(false));
+      maximizationParameter.ValueChanged += new EventHandler(MaximizationParameter_ValueChanged);
+      Parameters.Add(maximizationParameter);
+
       Parameters.Add(new ValueParameter<DoubleMatrixData>("Coordinates", "The x- and y-Coordinates of the cities.", new DoubleMatrixData(0, 0)));
+
+      ValueParameter<IPermutationCreator> solutionCreatorParameter = new ValueParameter<IPermutationCreator>("SolutionCreator", "The operator which should be used to create new TSP solutions.");
+      solutionCreatorParameter.ValueChanged += new EventHandler(SolutionCreatorParameter_ValueChanged);
+      Parameters.Add(solutionCreatorParameter);
+
+      ValueParameter<ITSPEvaluator> evaluatorParameter = new ValueParameter<ITSPEvaluator>("Evaluator", "The operator which should be used to evaluate TSP solutions.");
+      evaluatorParameter.ValueChanged += new EventHandler(EvaluatorParameter_ValueChanged);
+      Parameters.Add(evaluatorParameter);
+
       Parameters.Add(new ValueParameter<DoubleData>("BestKnownQuality", "The quality of the best known solution of this TSP instance."));
+
       RandomPermutationCreator creator = new RandomPermutationCreator();
+      creator.PermutationParameter.ActualName = "TSPTour";
       creator.LengthParameter.Value = new IntData(0);
-      SolutionCreator = creator;
-      Evaluator = new TSPRoundedEuclideanPathEvaluator();
+      SolutionCreatorParameter.Value = creator;
+      TSPRoundedEuclideanPathEvaluator evaluator = new TSPRoundedEuclideanPathEvaluator();
+      evaluator.CoordinatesParameter.ActualName = CoordinatesParameter.Name;
+      evaluator.PermutationParameter.ActualName = creator.PermutationParameter.ActualName;
+      evaluator.QualityParameter.ActualName = "TSPTourLength";
+      EvaluatorParameter.Value = evaluator;
+
+      operators = new OperatorSet();
+      var crossovers = ApplicationManager.Manager.GetInstances<IPermutationCrossover>().ToList();
+      crossovers.ForEach(x => {
+        x.ParentsParameter.ActualName = creator.PermutationParameter.ActualName;
+        x.ChildParameter.ActualName = creator.PermutationParameter.ActualName;
+      });
+      var manipulators = ApplicationManager.Manager.GetInstances<IPermutationManipulator>().ToList();
+      manipulators.ForEach(x => x.PermutationParameter.ActualName = creator.PermutationParameter.ActualName);
+      operators = new OperatorSet(crossovers.Cast<IOperator>().Concat(manipulators.Cast<IOperator>()));
     }
 
@@ -56,11 +115,33 @@
       TSPLIBParser parser = new TSPLIBParser(filename);
       parser.Parse();
-      Coordinates = new DoubleMatrixData(parser.Vertices);
-      int cities = Coordinates.Rows;
-      RandomPermutationCreator creator = new RandomPermutationCreator();
-      creator.LengthParameter.Value = new IntData(cities);
-      SolutionCreator = creator;
-      TSPRoundedEuclideanPathEvaluator evaluator = new TSPRoundedEuclideanPathEvaluator();
-      Evaluator = evaluator;
+      CoordinatesParameter.Value = new DoubleMatrixData(parser.Vertices);
+      int cities = CoordinatesParameter.Value.Rows;
+      SolutionCreatorParameter.Value.LengthParameter.Value = new IntData(cities);
+    }
+
+    private void MaximizationParameter_ValueChanged(object sender, EventArgs e) {
+      OnMaximizationChanged();
+    }
+    private void SolutionCreatorParameter_ValueChanged(object sender, EventArgs e) {
+      OnSolutionCreatorChanged();
+    }
+    private void EvaluatorParameter_ValueChanged(object sender, EventArgs e) {
+      OnEvaluatorChanged();
+    }
+
+    public event EventHandler MaximizationChanged;
+    private void OnMaximizationChanged() {
+      if (MaximizationChanged != null)
+        MaximizationChanged(this, EventArgs.Empty);
+    }
+    public event EventHandler SolutionCreatorChanged;
+    private void OnSolutionCreatorChanged() {
+      if (SolutionCreatorChanged != null)
+        SolutionCreatorChanged(this, EventArgs.Empty);
+    }
+    public event EventHandler EvaluatorChanged;
+    private void OnEvaluatorChanged() {
+      if (EvaluatorChanged != null)
+        EvaluatorChanged(this, EventArgs.Empty);
     }
   }
Index: trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPDistanceMatrixPathEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPDistanceMatrixPathEvaluator.cs	(revision 2857)
+++ trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPDistanceMatrixPathEvaluator.cs	(revision 2865)
@@ -22,5 +22,4 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
-using HeuristicLab.Operators;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -33,5 +32,5 @@
   [Creatable("Test")]
   [EmptyStorableClass]
-  public sealed class TSPDistanceMatrixPathEvaluator : SingleSuccessorOperator {
+  public sealed class TSPDistanceMatrixPathEvaluator : TSPEvaluator {
     public LookupParameter<DoubleMatrixData> DistanceMatrixParameter {
       get { return (LookupParameter<DoubleMatrixData>)Parameters["DistanceMatrix"]; }
@@ -40,7 +39,4 @@
       get { return (LookupParameter<Permutation.Permutation>)Parameters["Permutation"]; }
     }
-    public LookupParameter<DoubleData> QualityParameter {
-      get { return (LookupParameter<DoubleData>)Parameters["Quality"]; }
-    }
 
     public TSPDistanceMatrixPathEvaluator()
@@ -48,5 +44,4 @@
       Parameters.Add(new LookupParameter<DoubleMatrixData>("DistanceMatrix", "The distance matrix of the cities."));
       Parameters.Add(new LookupParameter<Permutation.Permutation>("Permutation", "The TSP solution given in path representation which should be evaluated."));
-      Parameters.Add(new LookupParameter<DoubleData>("Quality", "The evaluated quality of the given TSP solution."));
     }
 
Index: trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPEvaluator.cs	(revision 2865)
+++ trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPEvaluator.cs	(revision 2865)
@@ -0,0 +1,44 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Routing.TSP {
+  /// <summary>
+  /// A base class for operators which evaluate TSP solutions.
+  /// </summary>
+  [Item("TSPEvaluator", "A base class for operators which evaluate TSP solutions.")]
+  [EmptyStorableClass]
+  public abstract class TSPEvaluator : SingleSuccessorOperator, ITSPEvaluator {
+    public ILookupParameter<DoubleData> QualityParameter {
+      get { return (ILookupParameter<DoubleData>)Parameters["Quality"]; }
+    }
+
+    protected TSPEvaluator()
+      : base() {
+      Parameters.Add(new LookupParameter<DoubleData>("Quality", "The evaluated quality of the TSP solution."));
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPPathEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPPathEvaluator.cs	(revision 2857)
+++ trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPPathEvaluator.cs	(revision 2865)
@@ -22,5 +22,4 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
-using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -32,5 +31,5 @@
   [Item("TSPPathEvaluator", "A base class for operators which evaluate TSP solutions given in path representation.")]
   [EmptyStorableClass]
-  public abstract class TSPPathEvaluator : SingleObjectiveEvaluator {
+  public abstract class TSPPathEvaluator : TSPEvaluator {
     public LookupParameter<DoubleMatrixData> CoordinatesParameter {
       get { return (LookupParameter<DoubleMatrixData>)Parameters["Coordinates"]; }
